/*
 * SuppliersHandler.java
 *
 * Created on 10 de agosto de 2004, 17:56
 */

package com.fenalco.servlets.shopkeeper;

import java.io.IOException;

import javax.servlet.RequestDispatcher;
import javax.servlet.ServletConfig;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;

import com.fenalco.entities.User;
import com.fenalco.utilities.MessageBuilder;
import com.fenalco.utilities.database.ExecuteSQLException;
import com.fenalco.utilities.database.SQLUtilities;

/**
 * Este servlet procesa la solicitud de modificación de estado del proveedor con
 * respecto al usuario, es decir si el usuario quiere activar o desactivar un
 * proveedor para ver los productos de su catálogo. Recibe los parámetros <CODE>
 * id</CODE> y <CODE>newStatus</CODE> de la página misproveedores.jsp
 * 
 * @author Mario Linares Vásquez
 */
public class SuppliersHandler extends HttpServlet
{

	/**
	 * Inicializa el servlet.
	 * 
	 * @param config
	 * @throws ServletException
	 */
	public void init( ServletConfig config ) throws ServletException
	{
		super.init(config);

	}

	/**
	 * Destructor de el servlet.
	 */
	public void destroy( )
	{

	}

	/**
	 * Procesa solicitudes de los métodos HTTP <code>GET</code> y
	 * <code>POST</code>. Este método invoca la función miembro <CODE>
	 * changeStatus</CODE> con los parámetros <CODE>id</CODE>,<CODE>
	 * newStatus</CODE> y con el id del minorista qu se encuentra en el
	 * atributo <CODE>user</CODE> de la sesión, y luego redirecciona el flujo
	 * a el servlet misprovedores
	 * 
	 * @param request
	 *            servlet request
	 * @param response
	 *            servlet response
	 * @throws ServletException
	 * @throws IOException
	 */
	protected void processRequest( HttpServletRequest request,
			HttpServletResponse response ) throws ServletException, IOException
	{
		String url = "/minorista/misproveedores";
		String message = "";
        HttpSession session = request.getSession( false );

	    try
	    {
	        if( session == null || ( User )session.getAttribute( "user" ) == null || ( ( User )session.getAttribute( "user" ) ).getRoleId() != 3 )
	        {
				message = MessageBuilder.buildMessage(15);
				url = "/index.jsp";	        	
	        }
	        else
	        {	    		
				int newStatus = Integer.parseInt(request.getParameter("newStatus"));
				int supplierId = Integer.parseInt(request.getParameter("id"));
				int shopKeeperId = ((User) request.getSession().getAttribute("user"))
						.getCompanyId();
		
				if( this.changeStatus(shopKeeperId, supplierId, newStatus) == false )
				{
					message = MessageBuilder.buildMessage(7);
				}
	        }
	    }
	    catch( Exception e )
	    {
	        url="/logout";
	        message = MessageBuilder.buildMessage(15);
	    }


		request.setAttribute("message", message);
		RequestDispatcher dispatcher = getServletContext()
				.getRequestDispatcher(url);
		dispatcher.forward(request, response);
	}

	/**
	 * Procesa el método HTTP <code>GET</code>.
	 * 
	 * @param request
	 *            servlet request
	 * @param response
	 *            servlet response
	 * @throws ServletException
	 * @throws IOException
	 */
	protected void doGet( HttpServletRequest request,
			HttpServletResponse response ) throws ServletException, IOException
	{
		processRequest(request, response);
	}

	/**
	 * Procesa el método HTTP <code>POST</code>.
	 * 
	 * @param request
	 *            servlet request
	 * @param response
	 *            servlet response
	 * @throws ServletException
	 * @throws IOException
	 */
	protected void doPost( HttpServletRequest request,
			HttpServletResponse response ) throws ServletException, IOException
	{
		processRequest(request, response);
	}

	/**
	 * Retorna una breve description de el servlet.
	 * 
	 * @return
	 */
	public String getServletInfo( )
	{
		return "Short description";
	}

	/**
	 * Este método actualiza el estado del proveedor con respecto al minorista.
	 * Para tal efecto debe crear una instancia de la clase <CODE>SQLUtilities
	 * </CODE> y utilizar el método <CODE>query</CODE> con una consulta de
	 * tipo updtate sobre la tabla minorista_proveedor.
	 * 
	 * @param shopKeeperId
	 *            id del minorista
	 * @param supplierId
	 *            id del proveedor
	 * @param newStatus
	 *            identficador del estado nuevo
	 * @return boolean que representa el exito del proceso
	 */
	public boolean changeStatus( int shopKeeperId, int supplierId, int newStatus )
	{
		boolean flag = true;
		try
		{
			String query = new String("UPDATE minorista_proveedor"
					+ " SET mino_prov_catalogo=" + newStatus
					+ " WHERE empr_id=" + shopKeeperId + " AND pro_empr_id="
					+ supplierId + ";");

			SQLUtilities.execute(query);
		}
		catch (ExecuteSQLException qe)
		{
			System.out.println(qe.getMessage());
			flag = false;
		}

		return flag;
	}

}